% Lezione di lab RICREC  -16/04/2012- Classificatori Bayesiani - Marco Cristani
close all;
clear all;
clc



% ---------------------------------------
% Esercizio 1 Distribuzioni Gaussiane
% ---------------------------------------
% Siano date due distribuzioni Gaussiane monodimensionali N(mu1,sigma1) e
% N(mu2,sigma2). Fissati mu1,sigma1,mu2,sigma2:
% 1.Generare numerosi campioni da queste distribuzioni e visualizzarli
% 2.Verificare che le due campionature seguano una distribuzione Gaussiana calcolando e visualizzando gli istogrammi
% 3.Calcolare (e verificare) la media e la deviazione standard

%-- Istanziazione campioni
mu1         =   1;
sigma1      =   2;
mu2         =   20;
sigma2      =   3;

num_s       =   500;

Sample_set1 =   normrnd(mu1,sigma1,num_s,1);
Sample_set2 =   normrnd(mu2,sigma2,num_s,1);

%-- Visualizzazione campioni
Data        =   [Sample_set1;Sample_set2];

maxData     =   max(Data);
minData     =   min(Data);


h_G1d = figure; hold on;
h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');

axis([minData-1,maxData+1,0,2])
set(gcf,'name','Campioni Gaussiani')
set(gca,'ytick',[]);
h_m1 = line([mu1;mu1],[0;2]); 
set(h_m1,'color',[0,0,1]);
text(mu1+0.05,1,'\mu1','color',[0,0,1])

h_m2 = line([mu2;mu2],[0;2]);
set(h_m2,'color',[1,0,0]);
text(mu2+0.05,1,'\mu2','color',[1,0,0])

h_leg = legend([h_S1(1);h_S2(1);h_m1;h_m2],{strcat('N1: \mu1=',num2str(mu1),...
    ' \sigma1=',num2str(sigma1));...
    strcat('N2: \mu2=',num2str(mu2),' \sigma2=',num2str(sigma2));...
    '\mu1';...
    '\mu2'});


fprintf('mu1 = %3.5f; dev-std1 =%3.5f\n',mu1,sigma1)
fprintf('mu1 = %3.5f; dev-std1 =%3.5f\n',mu2,sigma2)


%fprintf('Stima media e varianza...')
est_mu1 = mean(Sample_set1);
est_sigma1 = std(Sample_set1);

est_mu2 = mean(Sample_set2);
est_sigma2 = std(Sample_set2);
%fprintf('OK.\n');


fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu1,est_sigma1)
fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu2,est_sigma2)

%-- Plot stime
set(h_G1d,'name','Campioni Gaussiani, confronto medie reali e stimate')
h_estm1 = line([est_mu1;est_mu1],[0;2]); 
set(h_estm1,'color',[0,0,1],'LineStyle','--');
text(est_mu1+0.05,1.5,'est. \mu1','color',[0,0,1])

h_estm2 = line([est_mu2;est_mu2],[0;2]);
set(h_estm2,'color',[1,0,0],'LineStyle','--');
text(est_mu2+0.05,1.5,'est. \mu2','color',[1,0,0])

delete(h_leg)

h_leg = legend([h_S1(1);h_S2(1);h_m1;h_m2;h_estm1;h_estm2],{strcat('N1: \mu1=',num2str(mu1),' \sigma1=',num2str(sigma1));...
    ,strcat('N2: \mu2=',num2str(mu2),' \sigma2=',num2str(sigma2));...
    ' \mu1';...
    ' \mu2';...
    'est. \mu1';...
    'est. \mu2'});



pause
%fprintf('Stima media e varianza...')
est_mu1 = mean(Sample_set1);
est_sigma1 = std(Sample_set1);

est_mu2 = mean(Sample_set2);
est_sigma2 = std(Sample_set2);
%fprintf('OK.\n');


fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu1,est_sigma1)
fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu2,est_sigma2)

%-- Plot stime
set(h_G1d,'name','Campioni Gaussiani, confronto medie reali e stimate')
h_estm1 = line([est_mu1;est_mu1],[0;2]); 
set(h_estm1,'color',[0,0,1],'LineStyle','--');
text(est_mu1+0.05,1.5,'est. \mu1','color',[0,0,1])

h_estm2 = line([est_mu2;est_mu2],[0;2]);
set(h_estm2,'color',[1,0,0],'LineStyle','--');
text(est_mu2+0.05,1.5,'est. \mu2','color',[1,0,0])

delete(h_leg)

h_leg = legend([h_S1(1);h_S2(1);h_m1;h_m2;h_estm1;h_estm2],{strcat('N1: \mu1=',num2str(mu1),' \sigma1=',num2str(sigma1));...
    ,strcat('N2: \mu2=',num2str(mu2),' \sigma2=',num2str(sigma2));...
    ' \mu1';...
    ' \mu2';...
    'est. \mu1';...
    'est. \mu2'});

%-- Errore stime
%fprintf('Calcolo errore stime...');
err_mu1 = abs(est_mu1-mu1);
err_sigma1 = abs(est_sigma1-sigma1);

err_mu2 = abs(est_mu2-mu2);
err_sigma2 = abs(est_sigma2-sigma2);
%fprintf('OK \n');

fprintf('Errore mu1 = %3.5f; Errore dev-std1 =%3.5f\n',err_mu1,err_sigma1);
fprintf('Errore mu2 = %3.5f; Errore dev-std2 =%3.5f\n',err_mu2,err_sigma2);

pause



%% Calcolo likelihood campioni

% Calcolo di likelihood di un campione, di ogni
%  distribuzione rispetto ad ogni classe;
l_d1c1 = normpdf(Sample_set1(1),mu1,sigma1);
%P(xd1|c1);
l_d1c2 = normpdf(Sample_set1(1),mu2,sigma2);
%P(xd1|c2);
l_d2c2 = normpdf(Sample_set2(1),mu2,sigma2);
%P(xd2|c2);
l_d2c1 = normpdf(Sample_set2(1),mu1,sigma1);
%P(xd2|c1);
%Controllate il valore delle differenti likelihood!

% Calcolo della likelihood di un gruppo di campioni
iter=0;
for i=[5,10,100,500]
    iter=iter+1;
tmp = normpdf(Sample_set1(1:i),mu1,sigma1);
%cosa contiene tmp?
l_d1c1(iter) = prod(tmp);
%P(xd1|c1);
l_d1c2(iter) = prod(normpdf(Sample_set1(1:i),mu2,sigma2));
%P(xd1|c2);
l_d2c2(iter) = prod(normpdf(Sample_set2(1:i),mu2,sigma2));
%P(xd2|c2);
l_d2c1(iter) = prod(normpdf(Sample_set2(1:i),mu1,sigma1));
%P(xd2|c1);
end
% cosa accade con la valutazione di 500 elementi?


% Calcolo della log likelihood di un gruppo di campioni
iter=0;
for i=[5,10,100,500]
    iter=iter+1;
tmp = log(normpdf(Sample_set1(1:i),mu1,sigma1));
%cosa contiene tmp?
ll_d1c1(iter) = sum(tmp);
%P(xd1|c1);
ll_d1c2(iter) = sum(log(normpdf(Sample_set1(1:i),mu2,sigma2)));
%P(xd1|c2);
ll_d2c2(iter) = sum(log(normpdf(Sample_set2(1:i),mu2,sigma2)));
%P(xd2|c2);
ll_d2c1(iter) = sum(log(normpdf(Sample_set2(1:i),mu1,sigma1)));
%P(xd2|c1);
end



% 1.Calcolare e visualizzare la campionatura x3, ottenuta con x3=x1+x2
% 2.Verificare che la campionatura segua una distribuzione Gaussiana calcolando e visualizzando listogramma
% 3.Calcolare la media e la varianza di x3, verificando la relazione con la media e la varianza di x1 e x2


% Variabile somma
SumS = Sample_set1+Sample_set2;

% Visualizzazione variabile somma
h_SumG1d = figure;
h_Sum = scatter(SumS,zeros(num_s,1),10,'r');
maxSumData     =   max(SumS);
minSumData     =   min(SumS);
axis([minSumData-1,maxSumData+1,0,2])

% Calcolo istogramma
pause
IstoSum = hist(SumS,10);
h_IstoSum = figure;
bar(IstoSum);
set(gcf,'name','Istogramma distribuzione somma');

% 1.2.6 -- Variabile somma
est_mean_Sum = mean(SumS); %in teoria, mu = mu1 + mu2;
est_std_Sum = std(SumS); % in teoria, std = sqrt(std1^2+std2^2);
% Per una dimostrazione, vedasi http://www.fisica.unipg.it/~santucci/laboratorio/nuova_pagina_3.htm
fprintf('Variabile somma: mu stimata = %3.5f; std stimata =%3.5f\n',est_mean_Sum,est_std_Sum);
pause


%-- 2D
num_s = 5000;

Mu1 = [3,6];
Cov1 = [2,0;0,6];
Sample_set2D =   mvnrnd(Mu1,Cov1,num_s);

h_G2d = figure; set(gcf,'name','Campioni Gaussiani 2D')
scatter(Sample_set2D(:,1),Sample_set2D(:,2),10); axis equal


%-- 3D
Mu3D1 = [3,6,0];
Cov3D1 = [2,0, 0;0,6,0;0,0,2];
Sample_set3D =   mvnrnd(Mu3D1,Cov3D1,num_s);

h_G3d = figure; set(gcf,'name','Campioni Gaussiani 3D')
scatter3(Sample_set3D(:,1),Sample_set3D(:,2),Sample_set3D(:,3),10); axis equal



pause

% -----------------------------------------------------
% Esercizio 2 Classificatore Bayesiano: caso semplice
% -----------------------------------------------------

Pw1=0.5;
Pw2=0.5;

Mu1 = 3;%
Mu2 = 0;%
sigma=1.5;

Sample_set1 =   normrnd(Mu1,sigma,num_s,1);
Sample_set2 =   normrnd(Mu2,sigma,num_s,1);
Data = [Sample_set1 ; Sample_set2];

% Disegno le funzioni discriminanti per la due classi di campioni Gaussiani
W1  = (1/sigma^2).*Mu1;
w10 = -(1/(2*sigma^2))*(Mu1'*Mu1) +log(Pw1);
G1 = sum(repmat(W1,1,num_s*2).*Data',1) + ones(1,num_s*2)*w10;

W2  = (1/sigma^2).*Mu2;
w20 = -(1/(2*sigma^2))*(Mu2'*Mu2) +log(Pw2);
G2 = sum(repmat(W2,1,num_s*2).*Data',1) + ones(1,num_s*2)*w20;

% Confine di decisione
W  = Mu1-Mu2;
X0 = 0.5*(Mu1+Mu2)-((sigma^2)./((Mu1-Mu2)'*(Mu1-Mu2))).*log(Pw1/Pw2).*(Mu1-Mu2);

h_CBayesG1D = figure; hold on;
[Ord,index_ord] = sort(Data,'ascend');
h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');
h_G1 = plot(Ord,G1(index_ord),'b');
h_G2 = plot(Ord,G2(index_ord),'r');
set(gcf,'name','Classificatore Bayesiano 2 classi 1D')
h_BayesG1D=line([X0;X0],[min([G1';G2']),max([G1';G2'])],'color',[0,0,0]);
%legend([h_G1;h_G2;h_BayesG1D],{'g_1(x)';'g_2(x)';'x_0'});
legend([h_S1(1);h_S2(1);h_G1;h_G2],{strcat('N1: \mu1=',num2str(Mu1),' \sigma1=',num2str(sigma));...
    strcat('N2: \mu2=',num2str(Mu2),' \sigma2=',num2str(sigma));...
    'g_1(x)';'g_2(x)'});



